package com.duanledexianxianxian.demo.redis.config;

import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;
import org.springframework.data.redis.connection.RedisConnectionFactory;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.core.script.RedisScript;
import org.springframework.data.redis.serializer.Jackson2JsonRedisSerializer;
import org.springframework.data.redis.serializer.RedisSerializer;
import org.springframework.data.redis.serializer.StringRedisSerializer;
import org.springframework.scripting.ScriptSource;
import org.springframework.scripting.support.ResourceScriptSource;


/**
 * @author duanledexianxianxian
 */
@Configuration
@Slf4j
public class RedisConfiguration {
    public final static String BEAN_NAME_CHECK_AND_SET_SCRIPT = "checkAndSetScript";

//    @Bean
//    public RedisTemplate<String, ?> redisTemplate(RedisConnectionFactory redisConnectionFactory) {
//
//        RedisTemplate<String, Object> redisTemplate = new RedisTemplate<String, Object>();
//        RedisSerializer<String> redisSerializer = new StringRedisSerializer();
//        RedisSerializer<?> jacksonSerializer = new Jackson2JsonRedisSerializer<>(Object.class);
//        // key采用String的序列化方式
//        redisTemplate.setKeySerializer(redisSerializer);
//        // value的序列化采用jackson
//        redisTemplate.setValueSerializer(jacksonSerializer);
//        // hash的key也采用String的序列化
//        redisTemplate.setHashKeySerializer(redisSerializer);
//        // hash的value也采用jackson
//        redisTemplate.setValueSerializer(jacksonSerializer);
//        redisTemplate.setConnectionFactory(redisConnectionFactory);
//        log.info("RedisTemplate序列化配置，转化方式：" + jacksonSerializer.getClass().getName());
//        return redisTemplate;
//    }


    /**
     * 读取脚本文件的方式有很多种，这里只是其中一种
     *
     * @return
     */
    @Bean(BEAN_NAME_CHECK_AND_SET_SCRIPT)
    public RedisScript<String> checkAndSetScript() {
        return RedisScript.of(new ClassPathResource("META-INF/scripts/checkandset.lua"), String.class);
    }
}
