package com.duanledexianxianxian.demo.redis.service;

import com.google.common.collect.Maps;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.test.context.junit.jupiter.SpringExtension;

import java.util.Map;


// Junit5使用ExtendWith加载Spring测试模块
@ExtendWith(SpringExtension.class)
@SpringBootTest
class RedisServiceTest {

    @Autowired
    RedisService redisService;
    @Autowired
    StringRedisTemplate redisTemplate;

    @Test
    void testTestRedis1() {
        String result = redisService.testRedis1();
        Assertions.assertEquals("Hello Redis", result);
    }

    @Test
    void testTestRedis2() {
        Long result = redisService.testRedis2(10L);
        Assertions.assertEquals(10L, result);
    }


    @Test
    void testTestRedis3() {
        Long result = redisService.testRedis2(30L);
        Assertions.assertEquals(-1, result);
    }

    @Test
    void testTestRedis4() {
        Long result = redisService.testRedis2(19L);
        Assertions.assertEquals(1L, result);
    }


    @Test
    void testTestRedis5() {
        Map<String, String> paramsMap = Maps.newHashMap();
        paramsMap.put("stock:1", "20");
        paramsMap.put("stock:2", "300");
        paramsMap.put("stock:3", "300");
        Map<String, Long> result = redisService.testRedis3(paramsMap);
        System.out.println("result:" + result);
    }

    @Test
    void testTestRedis6() {
        // 初始化数据
        Map<String, String> initDataMap = Maps.newHashMap();
        initDataMap.put("stock:1", "20");
        initDataMap.put("stock:2", "100");
        initDataMap.put("stock:3", "0");
        initDataMap.put("stock:4", "40");
        redisTemplate.opsForValue().multiSet(initDataMap);
        Map<String, String> paramsMap = Maps.newHashMap();
        paramsMap.put("stock:1", "20");
        paramsMap.put("stock:2", "300");
        paramsMap.put("stock:3", "300");
        paramsMap.put("stock:4", "2");
        Map<String, String> result = redisService.testRedis4(paramsMap);

        Assertions.assertEquals(result.get("stock:1"), "0");
        Assertions.assertEquals(result.get("stock:2"), "-1");
        Assertions.assertEquals(result.get("stock:3"), "-1");
        Assertions.assertEquals(result.get("stock:4"), "38");
    }


}

//Generated with love by TestMe :) Please report issues and submit feature requests at: http://weirddev.com/forum#!/testme
